#ifndef AMPIRE_UTILS_H_
#define AMPIRE_UTILS_H_		1


#define  GCTRL_RAMWR            0xC1	//0x22  /* Set or get GRAM data */
#define  GCTRL_RAMRD            0x80  /* Set or get GRAM data */


void setxypos(	unsigned int Left, unsigned int Right,
				unsigned int Top,  unsigned int Bottom);
void amp_write_data(unsigned int left, unsigned int right, 
					unsigned int top, unsigned int bottom, 
					unsigned short *color);
void write_cmd(unsigned char cmd);
unsigned short read_data(void);
void write_cmd_data(unsigned char cmd, unsigned short data);
void write_ram(unsigned short data);

void ampire_init();
void getMutex();
void releaseMutex();

unsigned long swap_long(unsigned long data);
unsigned short swap_short(unsigned short data);



#endif /*AMPIRE_UTILS_H_*/






