/*
 * Archivos del BSP modificados:
 * 	- bsp.c
 *  - customizeCache.c
 *  - cs.c
 * 
 * */

#include <stdio.h>
#include <stdlib.h>

 
 

#include "mpmc_def.h"
#include "scm_reg.h"
#include "gpiomux_def.h"


#include "ampire_cfg.h"
#include "touch.h"
#include "ampire_graphics.h"
#include "ampire_utils.h"

#include "appconf.h"
#include "tx_api.h"


#include "bitmap8.h"
#include "bitmap16.h"

/*
static char btn_vals[3][30] = {
    "Released",
    "Initial Press",
    "Held down"};
*/
point_t last_touch_point;
void mycallback(int x, int y, int up)
{
	//char pp[50];
   	point_t a,b;
   	 	
   	getMutex();
   	
   	last_touch_point.x = x; last_touch_point.y = y;
   	
	a.x = 	x-10; 	a.y=	y;
	b.x	=	x+10; 	b.y=	y;		
	amp_line(&a, &b, BLACK);    
	
	a.x = 	x; 	a.y=	y-10;
	b.x	=	x; 	b.y=	y+10;		
	amp_line(&a, &b, BLACK);    

    //sprintf(pp,"X: %d, Y: %d, up: %s", x, y, btn_vals[up]);
   // puts(pp);puts("\n");
    
    //write_at(x, y, pp, RED , RED, FONT_SIZE_8x8);
   	releaseMutex();
    
    return;
}





void applicationStart(void)
{
    int retval;
    char buffer[100];
	point_t a,b;
	
	amp_init();

    retval = amp_setupTouch(mycallback, AMP_DEFAULT_TOUCH_PIN);

    if(retval)
      printf("setup touch error: %d\n", retval);
	tx_thread_sleep(500);
	
	
	//amp_rotate(ROT_180);
    while(1)
    {        	
/* BMP TEST BEGIN*/  	
		//amp_draw_bitmap( planta8 );	
		//amp_write_at(0, 0, "BITMAP 320x240 8 BPP",WHITE , WHITE, FONT_SIZE_8x8);		
		//tx_thread_sleep(1500);	
		
		amp_draw_bitmap( planta16 );	
		amp_write_at(0, 0, "BITMAP 320x240 16 BPP",WHITE , WHITE, FONT_SIZE_8x8);		
		tx_thread_sleep(1500);				
    	
	   	//amp_draw_bitmap( mish8 );
	   	//amp_write_at(0, 0, "BITMAP 320x240 8 BPP",WHITE , WHITE, FONT_SIZE_8x8);	
		//tx_thread_sleep(1500);	    	
		
	   	amp_draw_bitmap( mish16 );
	   	amp_write_at(0, 0, "BITMAP 320x240 16 BPP",WHITE , WHITE, FONT_SIZE_8x8);	
		tx_thread_sleep(1500);	    	
    	
	   	amp_draw_bitmap( perro16 );
	   	amp_write_at(0, 0, "BITMAP 240x320 16 BPP",WHITE , WHITE, FONT_SIZE_8x8);	
		tx_thread_sleep(1500);	    	
    			       
	   	amp_draw_bitmap( degra_1 );
	   	amp_write_at(0, 0, "BITMAP 240x320 16 BPP",WHITE , WHITE, FONT_SIZE_8x8);	
		tx_thread_sleep(1500);	 
        
	   	amp_draw_bitmap( degra_2 );
	   	amp_write_at(0, 0, "BITMAP 240x320 16 BPP",WHITE , WHITE, FONT_SIZE_8x8);	
		tx_thread_sleep(1500);	         
/*BMP TEST END*/

/* LINE TEST BEGIN*/         
		amp_fillscreen(YELLOW);  

		a.x = SCREEN_WIDTH-1; 
		a.y = SCREEN_HEIGHT-1;
		b.x=0; 
		for(b.y=SCREEN_HEIGHT-1; b.y >=0; b.y-=20){		
			amp_line(&a, &b, BLACK);
			//tx_thread_sleep(100);
		}				
		for(b.x = 0,b.y = 0 ; b.x < SCREEN_WIDTH ;b.x+=20){		
			amp_line(&a, &b, BLACK);
			//tx_thread_sleep(100);
		}
		
		a.x = 0; 
		a.y = 0;
		b.x=SCREEN_WIDTH-1; 		
		for(b.y=0; b.y < SCREEN_HEIGHT; b.y+=20){		
			amp_line(&a, &b, BLACK);
			//tx_thread_sleep(100);
		}
		b.y = SCREEN_HEIGHT-1;		
		for(b.x = SCREEN_WIDTH-1;b.x >= 0 ; b.x-=20){		
			amp_line(&a, &b, BLACK);
			//tx_thread_sleep(100);
		}		

		b.x = 190; b.y = 120;
		a.x = 130; a.y = 120;		
		amp_line(&a, &b, BLUE);	
		tx_thread_sleep(500);
		
		b.x = 160; b.y = 100;
		a.x = 160; a.y = 140;		
		amp_line(&a, &b, BLUE);
		tx_thread_sleep(500);
				
//		a.x = 0; a.y = 0;		
//		b.x = 319; 	b.y = 0;				
//		amp_line(&a, &b, RED);	
//		tx_thread_sleep(500);			
		
		amp_fillscreen(WHITE);
		amp_write_at(10, 160, "Linea fuera de escala:", BLUE , BLUE, FONT_SIZE_8x15);		
		amp_write_at(20, 177, "Origen: (-30,-30)", BLUE , BLUE, FONT_SIZE_8x15);		
		amp_write_at(20, 194, "Fin:    (360,280)", BLUE , BLUE, FONT_SIZE_8x15);		
		
		//Lnea fuera de escala
		a.x = -30; 	a.y = -30;		
		b.x = 360;	b.y = 280;				
		amp_line(&a, &b, RED);
		tx_thread_sleep(1500);
	
/* LINE TEST END*/  	

/* CIRCLE TEST*/  		
		amp_fillscreen(YELLOW);
		a.x = 160; 	a.y = 120;		
		amp_circle(&a, 40, BLUE, TRUE);
		tx_thread_sleep(1000);
		
/* RECTANGLE TEST*/  				
		a.x = 30; 	a.y = 30;		
		b.x = 90;	b.y = 60;									
		amp_rectangle(&a, &b, GREEN+BLUE, TRUE);
		tx_thread_sleep(1000);
		
		a.x = 10; 	a.y = 50;		
		b.x = 290;	b.y = 200;									
		amp_rectangle(&a, &b, GREEN+BLUE, FALSE);	
		tx_thread_sleep(1000);	

		
//TEXT TEST		
		amp_fillscreen(ORANGE);
    	amp_write_at(20, 50, "Text test:", BLACK , BLACK, FONT_SIZE_8x15);
    	tx_thread_sleep(1000);
    	amp_write_at(40, 80, "-Font 8x15, no back-color", RED , RED, FONT_SIZE_8x15);
    	tx_thread_sleep(1000);		
    	amp_write_at(40, 100, "-Font 8x15, back-color black", WHITE , BLACK, FONT_SIZE_8x15);	
    	tx_thread_sleep(1000);	    	
    	amp_write_at(40, 120, "-size 8x8 color black, backColor none", BLACK , BLACK, FONT_SIZE_8x8);			      
    	tx_thread_sleep(1000);
    	amp_write_at(40, 140, "-font 5x7 color green, backColor black", GREEN , BLACK, FONT_SIZE_5x7);	
    	tx_thread_sleep(1000);
    	amp_write_at(40, 160, "-font 5x7 color green, backColor none", GREEN , GREEN, FONT_SIZE_5x7);			          	
        tx_thread_sleep(1000);
    				          	
        tx_thread_sleep(2000);        
        
/*
    	amp_rotate(ROT_90);
		tx_thread_sleep(1000);

		amp_rotate(ROT_180);
		tx_thread_sleep(1000);

		amp_rotate(ROT_270);
		tx_thread_sleep(1000);

		amp_rotate(ROT_0);
		tx_thread_sleep(1000);
*/

/* COLOR TEST */  		
        printf("Color test\n");
        amp_color_test(NULL);	
		tx_thread_sleep(500);

        
        printf("Rainbow FPS test\n");
        retval = amp_rainbow_fps_test(100);        
        sprintf(buffer,"100 frames done in %d ticks (~%d fps)", retval, (100 / ((retval)/NABspTicksPerSecond)));
        amp_write_at(10, 120, buffer, BLUE , WHITE, FONT_SIZE_8x15);
        tx_thread_sleep(1000);


/*
        printf("Backlight Disable\n");
        AMP_BACKLIGHT_OFF;
        tx_thread_sleep(200);

        printf("Backlight Enable\n");
        AMP_BACKLIGHT_ON;
        tx_thread_sleep(200);
*/
   /**/
         
    }

	tx_thread_suspend(tx_thread_identify());
}


void applicationTcpDown(void)
{
    static int ticksPassed = 0;
    ticksPassed++;
	return;
}


